//
//  PCISError.h
//  PayControl
//
//  Created by Roman Kolesnichenko on 05.09.16.
//  Copyright © 2016 SafeTech. All rights reserved.
//


//typedef NS_ENUM(NSInteger, PCIS_ERROR)
//{
//    /** Ошибок нет */
//    PCIS_ERROR_OK                                   = -1,
//    /** Нет Интернет-соединения */
//    PCIS_ERROR_NO_CONNECTION                        = 0,
//    /** Сервер временно не доступен */
//    PCIS_ERROR_SERVER_NOT_AVAILABLE                 = 1,
//    /** Неизвестная ошибка */
//    PCIS_ERROR_GENERAL                              = 2,
//    /** Такой токен уже зарегистрирован */
//    PCIS_ERROR_PUSH_TOKEN_ALREADY_REGISTERED        = 3,
//    /** Токен не может быть пустым */
//    PCIS_ERROR_PUSH_TOKEN_NOT_VALID                 = 4,
//    /** URL не найден */
//    PCIS_ERROR_URL_NOT_FOUND                        = 5,
//    /** Ошибка авторизации (HTTP code: 401) */
//    PCIS_ERROR_NOT_AUTHORIZED                       = 6,
//    /** Требуется ввод пароля */
//    PCIS_ERROR_KEY_HANDLE_INVALID                   = 7,
//    /** Отпечаток уже установлен */
//    PCIS_ERROR_FINGERPRINT_ALREADY_SET              = 8,
//    /** Операция не поддерживается */
//    PCIS_ERROR_OPERATION_NOT_SUPPORTED              = 9,
//    /** Статус транзакции неверный */
//    PCIS_ERROR_TRANSACTION_STATUS_ERROR               = 10
//    
//};

typedef NS_ENUM(NSInteger, PCIS_ERROR)
{
    /** Ошибок нет */
    PCIS_ERROR_OK                                   = -1,
    /** Нет Интернет-соединения */
    PCIS_ERROR_NO_CONNECTION                        = 0,
    /** Сервер временно не доступен */
    PCIS_ERROR_SERVER_NOT_AVAILABLE                 = 1,
    /** Неизвестная ошибка */
    PCIS_ERROR_GENERAL                              = 2,
    /** Такой токен уже зарегистрирован */
    PCIS_ERROR_PUSH_TOKEN_ALREADY_REGISTERED        = 3,
    /** Токен не может быть пустым */
    PCIS_ERROR_PUSH_TOKEN_NOT_VALID                 = 4,
    /** URL не найден */
    PCIS_ERROR_URL_NOT_FOUND                        = 5,
    /** Ошибка авторизации (HTTP code: 401) */
    PCIS_ERROR_NOT_AUTHORIZED                       = 6,
    /** Требуется ввод пароля */
    PCIS_ERROR_KEY_HANDLE_INVALID                   = 7,
    /** Отпечаток уже установлен */
    PCIS_ERROR_FINGERPRINT_ALREADY_SET              = 8,
    /** Операция не поддерживается */
    PCIS_ERROR_OPERATION_NOT_SUPPORTED              = 9,
    /** Статус транзакции неверный */
    PCIS_ERROR_TRANSACTION_STATUS_ERROR               = 10,
    /**
     * Ошибка в настройках ИС
     */
    PCIS_ERROR_SYSTEM_PROPERTY_ERROR = 200,
    /**
     * ID системы не задан
     */
    PCIS_ERROR_SYSTEM_ID_IS_NULL = 201,
    /**
     * ID системы неверен
     */
    PCIS_ERROR_SYSTEM_ID_IS_WRONG = 202,
    /**
     * Система не найдена
     */
    PCIS_ERROR_SYSTEM_NOT_FOUND = 203,
    /**
     * Система удалена
     */
    PCIS_ERROR_SYSTEM_IS_DELETED = 204,
    /**
     * Имя системы не задано
     */
    PCIS_ERROR_SYSTEM_NAME_IS_NULL = 205,
    /**
     * ID пользователя не задан
     */
    PCIS_ERROR_USER_ID_IS_NULL = 206,
    /**
     * Префикс ID пользователя не задан
     */
    PCIS_ERROR_USER_ID_PREF_IS_NULL = 207,
    /**
     * Пользователь не найден
     */
    PCIS_ERROR_USER_NOT_FOUND = 208,
    /**
     * Пользователь удален
     */
    PCIS_ERROR_USER_IS_DELETED = 209,
    /**
     * ЭП не верна
     */
    PCIS_ERROR_DS_VERIFY_ERROR  = 210,
    /**
     * Структура ЭП не верна
     */
    PCIS_ERROR_DS_STRUCT_ERROR = 211,
    /**
     * Тип хранилища неверен
     */
    PCIS_ERROR_STORE_TYPE_IS_WRONG = 212,
    /**
     * Alias ключевого контейнера не задан
     */
    PCIS_ERROR_KEY_CONTAINER_ALIAS_IS_NULL = 213,
    /**
     * Ключевой контейнер не существует
     */
    PCIS_ERROR_KEY_CONTAINER_NOT_EXISTS = 214,
    /**
     * Неверные данные транзакции (User ID не совпадает)
     */
    PCIS_ERROR_TRANSACTION_DATA_UID_ERROR = 215,
    /**
     * Неверные данные транзакции
     */
    PCIS_ERROR_TRANSACTION_DATA_ERROR = 216,
    /**
     * Данные транзакции не заданы
     */
    PCIS_ERROR_TRANSACTION_DATA_IS_NULL = 217,
    /**
     * Неверный шаблон отчета
     */
    PCIS_ERROR_REPORT_TPL_IS_NULL = 218,
    /**
     * Ошибка в запросе
     */
    PCIS_ERROR_REQUEST_ERROR = 219,
    /**
     * ID системы не уникален
     */
    PCIS_ERROR_SYSTEM_ID_NOT_UNIQUE = 220,
    /**
     * Подпись запроса невалидна
     */
    PCIS_ERROR_REQUEST_SIGNATURE_NOT_VALID = 221,
    /**
     * Система не является доверенной
     */
    PCIS_ERROR_SYSTEM_NOT_VALID = 222,
    /**
     * Транзакция не найдена
     */
    PCIS_ERROR_TRANSACTION_IS_NULL = 231,
    /**
     * Данные транзакции уже проверены
     */
    PCIS_ERROR_TRANSACTION_CHECKED = 232,
    /**
     * Невозможно распознать запрос на регистрацию системы
     */
    PCIS_ERROR_ERROR_PARSE_REGISTER_SYSTEM_INFO = 233,
    /**
     * Некорректный тип пользователя
     */
    PCIS_ERROR_INCORRECT_USER_TYPE = 234,
    /**
     * Пустая коллекция
     */
    PCIS_ERROR_COLLECTION_IS_EMPTY = 235,
    /**
     * Резльтатов нет
     */
    PCIS_ERROR_NO_RESULT = 236,
    /**
     * Pin-код не задан
     */
    PCIS_ERROR_PIN_IS_EMPTY = 237,
    /**
     * Отпечаток пользователя не задан
     */
    PCIS_ERROR_FPRINT_IS_EMPTY = 238,
    /**
     * Неверный OTP
     */
    PCIS_ERROR_OTP_IS_NOT_VALID = 239,
    /**
     * Истек срок регистрации
     */
    PCIS_ERROR_VALID_DATE_EXPIRED = 240,
    /**
     * Неверный тип системы
     */
    PCIS_ERROR_SYSTEM_TYPE_IS_WRONG = 241,
    /**
     * Неверно задана длина 2-й части ключевой информации
     */
    PCIS_ERROR_SPART_LENGTH_IS_WRONG = 242,
    /**
     * Неверно задан тип данных
     */
    PCIS_ERROR_DATA_TYPE_IS_WRONG = 243,
    /**
     * Код подтвержения неверен
     */
    PCIS_ERROR_INVALID_HMAC = 244,
    /**
     * Нет активной ключевой информации
     */
    PCIS_ERROR_KEY_INFO_NOT_FOUND = 245,
    /**
     * Неверный тип системы
     */
    PCIS_ERROR_WRONG_SYSTEM_TYPE = 246,
    /**
     * Отпечаток уже установлен
     */
    PCIS_ERROR_FPRINT_IS_NOT_EMPTY = 247,
    /**
     * Неверный код аутентификации
     */
    PCIS_ERROR_WRONG_AUTH_CODE = 248,
    /**
     * Не задан тип подтверждения
     */
    PCIS_ERROR_CONFIRM_TYPE_IS_NULL = 249,
    /**
     * Не задан тип хранилища
     */
    PCIS_ERROR_STORE_TYPE_IS_NULL = 250,
    /**
     * Не задан тип устройства
     */
    PCIS_ERROR_DEVICE_TYPE_IS_NULL = 251,
    /**
     * Не задан тип данных
     */
    PCIS_ERROR_TRANSACTION_DATA_TYPE_IS_NULL = 252,
    /**
     * Префикс ID превышает допустимую длину
     */
    PCIS_ERROR_USER_ID_PREF_TOO_LONG = 253,
    /**
     * Неверно задана длина кода подтверждения
     */
    PCIS_ERROR_CONFIRM_CODE_LENGTH_IS_WRONG = 254,
    /**
     * Код подтверждения не задан
     */
    PCIS_ERROR_CONFIRM_CODE_IS_NULL = 255,
    /**
     * ID транзакции не задан
     */
    PCIS_ERROR_TRANSACTION_ID_IS_NULL = 256,
    /**
     * Не задан список статусов
     */
    PCIS_ERROR_STATUS_LIST_IS_EMPTY = 257,
    /**
     * ID устройства не задано
     */
    PCIS_ERROR_DEVICE_ID_IS_NULL = 258,
    /**
     * Тип устройства неправильный
     */
    PCIS_ERROR_DEVICE_TYPE_IS_INCORRECT = 259,
    /**
     * Код подтвержения неверен
     */
    PCIS_ERROR_INVALID_OTP = 261,
    /**
     * Неподдерживаемый формат параметра kdfFunc
     */
    PCIS_ERROR_INVALID_KDF = 263,
    /**
     * Неверно задана длина пин-кода
     */
    PCIS_ERROR_PIN_LENGTH_IS_WRONG = 264,
    /**
     * Идентификатор уведомления не найден
     */
    PCIS_ERROR_PUSH_NOT_FOUND = 265,
    /**
     * Статус транзакции неверный
     */
    PCIS_ERROR_TRANSACTION_STATUS_INVALID = 267,
    /**
     * Код аутентификации не задан
     */
    PCIS_ERROR_AUTH_CODE_IS_NULL = 268,
    /**
     * Ошибка в списке статусов
     */
    PCIS_ERROR_STATUS_LIST_IS_INCORRECT = 269,
    /**
     * Причина отмены не передана
     */
    PCIS_ERROR_DECLINE_REASON_IS_NULL = 270,
    /**
     * Транзакция с таким id уже существует
     */
    PCIS_ERROR_TRANSACTION_IS_NOT_UNIQUE = 271,
    /**
     * Дата закрытия биллингового периода сохранена неверно
     */
    PCIS_ERROR_BILL_DATE_CORRUPTED = 272,
    /**
     * Дата закрытия биллингового периода пользователя сохранена неверно
     */
    PCIS_ERROR_USER_BILL_DATE_CORRUPTED = 273,
    /**
     * Транзакция помечена как удаленная
     */
    PCIS_ERROR_TRANSACTION_IS_DELETED = 274,
    /**
     * Биллинг на данную дату уже закрыт
     */
    PCIS_ERROR_BILL_REQUEST_ALREADY_PROCESSED = 275,
    /**
     * Открытый ключ отсутствует
     */
    PCIS_ERROR_PUBKEY_IS_EMPTY = 276,
    /**
     * Открытый ключ уже установлен
     */
    PCIS_ERROR_PUBKEY_IS_NOT_EMPTY = 277,
    /**
     * Подпись неверна
     */
    PCIS_ERROR_SIGNATURE_IS_INVALID = 278,
    /**
     * Подпись не задана
     */
    PCIS_ERROR_SIGNATURE_IS_NULL = 279,
    /**
     * Подпись или код подтверждения должны быть заданы
     */
    PCIS_ERROR_SIGNATURE_AND_CONFIRM_CODE_ARE_NULL = 280,
    /**
     * Вышло время жизни транзакции
     */
    PCIS_ERROR_TRANSACTION_EXPIRED = 281,
    /**
     * Версия JSON-запроса не поддерживается
     */
    PCIS_ERROR_JSON_SCHEME_NOT_SUPPORTED = 282,
    /**
     * JSON-запрос не соответствует схеме
     */
    PCIS_ERROR_JSON_REQUEST_INCORRECT = 283,
    /**
     * Ошибка загрузки лицензии
     */
    PCIS_ERROR_LICENSE_UPDATE_ERROR = 284,
    /**
     * Срок действия лицензии истёк
     */
    PCIS_ERROR_LICENSE_EXPIRED = 285,
    /**
     * Количество пользователей в лицензии достигнуто
     */
    PCIS_ERROR_LICENSE_USER_COUNT_EXCEEDED = 286,
    /**
     * Тип лицензирования был изменен
     */
    PCIS_ERROR_BILLING_TYPE_CORRUPTED = 287,
    /**
     * Хедер авторизации неверный
     */
    PCIS_ERROR_HTTP_AUTHORIZATION_WRONG = 288,
    
    /**
     Операция не поддерживается
     */
    PCIS_ERROR_OPERATION_NOT_SUPPORTED_ON_SERVICE = 289,

    /**
     Срок действия ключа истёк
     */
    PCIS_ERROR_KEY_EXPIRED = 295,
    
};

/**
 * Класс ошибок при работе с PC IS
 */
@interface PCISError : NSObject

/// ****************************************************************************
/// @name Методы класса
/// ****************************************************************************

/** Создание экземпляра объекта ошибки на основе кода ошибки - PCIS_ERROR
 @param errorCode код ошибки
 */
+(nullable instancetype)errorWithCode:(PCIS_ERROR)errorCode;

/** Создание экземпляра объекта ошибки на основе строки с ошибкой, при этом errorCode будет равен - PCIS_ERROR_GENERAL
 @param errorString строка с кастомным описание ошибки
 */
+(nullable instancetype)errorWithString:(NSString* _Nullable)errorString;

/* Создание экземпляра объекта ошибки на основе HTTP кода ошибки
 @param httpErrorCode HTTP код ошибки
 @param httpPayload содержимое HTTP запроса вызвавшего ошибку
 */
//+(instancetype)errorWithHTTPCode:(NSUInteger)httpErrorCode httpPayload:(NSString*)httpPayload;

/** Создание экземпляра объекта ошибки на основе ответа HTTP
 @param sessionTask HTTP таск
 @param request запрос
 @discuss Если код HTTP ответа находится в диапазоне 200 - 299 errorCode = PCIS_ERROR_OK иначе PCIS_ERROR_NOT_AUTHORIZED (HTTP code: 401) или PCIS_ERROR_GENERAL 
 */
+(nullable instancetype)errorWithHTTPSessionTask:(NSURLSessionDataTask* _Nonnull)sessionTask request:(NSURLRequest* _Nullable)urlRequest response:(NSURLResponse* _Nullable)response serverErrorString:(NSString* _Nullable)serverErrorString;

-(void)updateErrorCodeWithServerString:(NSString* _Nonnull)string;

/// ****************************************************************************
/// @name Свойства
/// ****************************************************************************

/** Код ошибки */
@property(nonatomic, readonly) PCIS_ERROR errorCode;

/** Строковое описание ошибки*/
@property(nonatomic, readonly, nullable) NSString *errorMessage;



/** Код статуса HTTP. Имеет значение если ошибка создавалась через метод класса errorWithHTTPCode:httpPayload: или errorWithHTTPResponse: иначе возвращает -1 */
@property(nonatomic, readonly) NSInteger getHTTPCode;

/** Cодержимое HTTP запроса. Имеет значение если ошибка создавалась через метод класса errorWithHTTPCode:httpPayload: или errorWithHTTPResponse: иначе  возвращает nil */
@property(nonatomic, readonly, nullable) NSDictionary *getHTTPPayload;

@end
